# - Required modules
require mrfioc2,2.2.1rc3
require busy,1.7.2_c596e1c
require ts2evm,1.0.0

# - Standard modules
require iocStats,3.1.16
require autosave,5.10.0
require caPutLog,b544f92
require recsync,1.3.0-9705e52
require ess,0.0.1

epicsEnvSet(PREFIX, "TD-TS2:TS-EVM-01")

# - Load standard timing modules environment
iocshLoad "$(mrfioc2_DIR)/mtca.iocsh"
iocshLoad "$(mrfioc2_DIR)/ts.iocsh"
iocshLoad "$(mrfioc2_DIR)/evm.iocsh" "P=$(PREFIX), OBJ=EVM, PCIID=09:00.0, U=:EVRU-, D=:EVRD-"

# - Load TS2 EVM application
dbLoadRecords("ts2_evm_controls.template", "P=$(PREFIX):, EVGPREFIX=$(PREFIX):")

# - Load standard ESS modules
iocshLoad("$(iocStats_DIR)/iocStats.iocsh", "IOCNAME=$(PREFIX)")

var(reccastTimeout, 5.0)
var(reccastMaxHoldoff, 5.0)
epicsEnvSet("RECSYNCPREFIX", "$(PREFIX)")
iocshLoad("$(recsync_DIR)/recsync.iocsh", "IOCNAME=$(RECSYNCPREFIX)")

epicsEnvSet("AS_REMOTE", "/opt/autosave")
epicsEnvSet("AS_FOLDER", "$(PREFIX)")
iocshLoad("$(autosave_DIR)/autosave.iocsh", "AS_TOP=$(AS_REMOTE),IOCNAME=$(AS_FOLDER)")

## Logging environment variables
epicsEnvSet("LOG_SERVER_NAME", "$(LOG_SERVER_NAME=localhost)")
epicsEnvSet("ERRORLOG_SERVER_PORT", "$(ERRORLOG_SERVER_PORT=9001)")
epicsEnvSet("CAPUTLOG_SERVER_PORT", "$(CAPUTLOG_SERVER_PORT=9001)")
epicsEnvSet("FACNAME", "$(FACNAME=)")
#iocshLoad("$(ess_DIR)/iocLog.iocsh", "LOG_INET=$(LOG_SERVER_NAME),LOG_INET_PORT=$(ERRORLOG_SERVER_PORT),FACNAME=$(FACILITY_NAME=),IOCNAME=$(PREFIX)")
#iocshLoad("$(caPutLog_DIR)/caPutLog.iocsh", "LOG_INET=$(LOG_SERVER_NAME),LOG_INET_PORT=$(CAPUTLOG_SERVER_PORT)")

# - Start IOC
iocInit

# - Load EVM standard after init snippet
iocshLoad("$(mrfioc2_DIR)/evgr.iocsh","P=$(PREFIX), INTRF=, INTPPS=")

dbpf $(PREFIX):Enable-Sel "Ena Master"
dbpf $(PREFIX):1ppsInp-Sel "Sys Clk"

# - Set MXC0 to generate 14 Hz
dbpf $(PREFIX):Mxc0-Prescaler-SP 6289464
dbpf $(PREFIX):Mxc0-Polarity-Sel "Orginal"

# - Generate event 14 upon trigger on Mxc0
dbpf $(PREFIX):TrigEvt0-EvtCode-SP  14
dbpf $(PREFIX):TrigEvt0-TrigSrc-Sel "Mxc0"

# - Configure sequencers
dbpf $(PREFIX):SoftSeq0-RunMode-Sel "Normal"
dbpf $(PREFIX):SoftSeq0-TsResolution-Sel "uSec"
dbpf $(PREFIX):SoftSeq0-TrigSrc-0-Sel "Mxc0"
dbpf $(PREFIX):SoftSeq0-Load-Cmd "1"

dbpf $(PREFIX):SoftSeq1-RunMode-Sel "Normal"
dbpf $(PREFIX):SoftSeq1-TsResolution-Sel "uSec"
dbpf $(PREFIX):SoftSeq1-TrigSrc-0-Sel "Mxc0"
dbpf $(PREFIX):SoftSeq1-Load-Cmd "1"

# - Start sequencers
dbpf $(PREFIX):SeqSelecCalc.PROC "1"

